// Artefakt
package artefakt

import (
	"fmt"
	"sqmAufgabeTracing/set" //TODO
)

var idcount int = 1

/* verwaltet die Sammlung aller Artefakte, ersetzt so
   einen Controller, der auch hier sinnvoll waere;
   reicht hier, da keine weitere Controller-Funktionalitaet,
   sonst sicherlich kritischer Stil */
var alle = make(map[int]*Artefakt)

///////////

type Artefakt struct {
	id      int
	inhalt  string
	gruppen set.Set /* alternativ als Referenz */
}

// diskutabel ob new Objekt oder Referenz liefert, hier muss es Referenz sein
// da in alle weitergenutzt (formal ist eigentlich eine Referenz sauberer)
// New erhaelt Namen des Artefakts und der ersten Gruppe die ihm zugeordnet wird
func New(inhalt string, gruppe string) *Artefakt {
	ergebnis := &Artefakt{}
	ergebnis.id = idcount
	idcount = idcount + 1
	ergebnis.inhalt = inhalt
	ergebnis.gruppen = set.New()
	ergebnis.AddGruppe(gruppe)
	alle[ergebnis.id] = ergebnis
	return ergebnis
}

/* gibt keine statische Polymorphie, Tricks mit ...interface{} denkbar
func New(inhalt string, gruppen set.Set) Artefakt {
    ... // is nich
}
*/

func (a *Artefakt) AddGruppe(grp string) {
	a.gruppen.Add(grp)
}

func (a *Artefakt) HasGruppe(grp string) bool {
	return a.gruppen.Has(grp)
}

func (a *Artefakt) String() string {
	return fmt.Sprintf("(%d) %s %s", a.id, a.inhalt, a.gruppen)
}

func (a *Artefakt) GetId() int {
	return a.id
}

//Controller-Funktion
func Alle() *map[int]*Artefakt {
	return &alle
}

func Get(id int) (*Artefakt, bool) {
	value, ok := alle[id]
	// return alle[id] geht interessanterweise nicht
	return value, ok
}
