package main

import (
	"fmt"
	"sqm/sqmAufgabeTracing/artefakt"
	"sqm/sqmAufgabeTracing/zuordnung"
	"sqm/sqmAufgabeTracing/zuordnungsliste"
)

func main() {
	ak1 := artefakt.New("Ak1", "Aktion")
	ak2 := artefakt.New("Ak2", "Aktion")
	ak3 := artefakt.New("Ak3", "Aktion")
	ak4 := artefakt.New("Ak4", "Aktion")
	ak5 := artefakt.New("Ak5", "Aktion")

	afo1 := artefakt.New("Afo1", "Anforderung")
	afo2 := artefakt.New("Afo2", "Anforderung")
	afo3 := artefakt.New("Afo3", "Anforderung")
	afo4 := artefakt.New("Afo4", "Anforderung")
	afo5 := artefakt.New("Afo5", "Anforderung")
	afo6 := artefakt.New("Afo6", "Anforderung")

	kl1 := artefakt.New("Kl1", "Klasse")
	kl2 := artefakt.New("Kl2", "Klasse")
	kl3 := artefakt.New("Kl3", "Klasse")

	aa := zuordnung.New("Aktion", "Anforderung")
	aa.Zuordnen(ak1, afo1, 100)
	aa.Zuordnen(ak2, afo2, 100)
	aa.Zuordnen(ak3, afo3, 40)
	aa.Zuordnen(ak3, afo4, 60)
	aa.Zuordnen(ak4, afo5, 80)

	ak := zuordnung.New("Anforderung", "Klasse")
	ak.Zuordnen(afo1, kl1, 100)
	ak.Zuordnen(afo2, kl1, 20)
	ak.Zuordnen(afo2, kl2, 80)
	ak.Zuordnen(afo3, kl1, 30)
	ak.Zuordnen(afo3, kl3, 50)
	ak.Zuordnen(afo4, kl2, 100)
	ak.Zuordnen(afo6, kl2, 100)

	zli := zuordnungsliste.New()
	fmt.Println("aa hinzu: ", zli.Hinzu(aa)) // auch &aa denkbar
	fmt.Println("ak hinzu: ", zli.Hinzu(ak))
	fmt.Println("ak3 zugeordnet: ", zli.Zugeordnet(ak3.GetId()))
	fmt.Println("ak5 zugeordnet: ", zli.Zugeordnet(ak5.GetId()))
	fmt.Println("kl1 abhaengig: ", zli.Abhaengig(kl1.GetId()))
	fmt.Println("kl3 abhaengig: ", zli.Abhaengig(kl3.GetId()))
	fmt.Println("nicht zugeordnet: ", zli.NichtZugeordnet())
	fmt.Println("nicht abhaengig: ", zli.NichtAbhaengig())
	fmt.Println("nicht vollstaendig zugeordnet: ",
		zli.NichtVollstaendigZugeordnet())
}
